// This file is part of the pdr/pdx project.
// Copyright (C) 2010 Torsten Mueller, Bern, Switzerland
//
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation, either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __ENCODING_H
#define __ENCODING_H

#include <Poco/TextEncoding.h>

typedef set<string> EncodingNames;

//=== global encoding functions ============================================
void			InitEncodings ();

void			GetEncodingNames (EncodingNames& names);

Poco::TextEncoding&	GetEncoding (); // default-encoding (UTF-8)
Poco::TextEncoding&	GetEncoding (const string& encoding);

string			ConvertFrom (const string& text, Poco::TextEncoding& from);
string			ConvertTo (const string& text, Poco::TextEncoding& to);

#endif
